<template>
	<div :class="[$style.row, { [$style.mobile]: mobile }]">
		<div :class="$style.info">
			<h3 v-if="item.heading" :class="$style.itemHeading">
				{{ item.heading }}
			</h3>

			<div v-if="item.description" v-rich-content class="u-copy" :class="$style.desc" v-html="item.description" />
		</div>

		<div v-if="index === 0 || !isServer" :class="$style.right">
			<div v-if="(item.imageMobile && item.imageMobile.url) || (item.image && item.image.url)" :class="$style.image">
				<BaseImage
					:image="item.imageMobile || {}"
					:images="{ medium: item.image || {} }"
					sizes="(min-width: 1200px) 324px, (min-width: 1024px) calc((100vw - 60px) * 0.3), (min-width: 768px) 39vw, 80vw"
					compression-level="medium"
				/>
			</div>

			<div
				v-if="
					!mobile &&
					((item.next && item.next.imageMobile && item.next.imageMobile.url) ||
						(item.next && item.next.image && item.next.image.url))
				"
				:class="[$style.image, $style.nextImage]"
				@click="showTimeline(index + 1)"
			>
				<BaseImage
					:image="item.next.imageMobile || {}"
					:images="{ medium: item.next.image || {} }"
					sizes="(min-width: 1200px) 324px, (min-width: 1024px) calc((100vw - 60px) * 0.3), (min-width: 768px) 39vw, 80vw"
					compression-level="medium"
				/>
			</div>
		</div>
	</div>
</template>

<script>
export default {
	props: {
		item: {
			type: Object,
			required: true,
		},

		mobile: {
			type: Boolean,
			default: false,
		},

		index: {
			type: Number,
			required: true,
		},

		isServer: {
			type: Boolean,
			required: true,
		},
	},

	methods: {
		showTimeline(index) {
			this.$emit('showTimeline', index);
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.row {
	display: flex;
	flex: 0 0 auto;
	flex-direction: column-reverse;
	justify-content: flex-end;
	width: 100%;
	padding: 0 size('s');
	margin-right: -100%;
	visibility: hidden;
	opacity: 0;

	@include transition('fade-hide');

	@include above('medium') {
		flex-direction: row;
		align-items: center;
		justify-content: flex-start;
	}

	&:global(.isActive),
	&.mobile {
		visibility: visible;
		opacity: 1;
	}
}

.info {
	flex: 0 0 auto;
	padding-bottom: size('m');

	@include above('medium') {
		width: 45%;
		padding-right: 8%;
		padding-bottom: 0;
	}

	@include above('large') {
		width: 35%;
	}
}

.itemHeading {
	max-width: 38rem;
	margin-bottom: size('s');
	font-weight: 300;

	@include use-text-style('heading-300');
}

.desc {
	p {
		&:not(:last-child) {
			margin-bottom: size('s');
		}
	}

	a {
		font-weight: 700;
		color: inherit;

		&:hover,
		&:focus {
			color: color('text');
		}
	}
}

.right {
	display: flex;
	flex: 0 0 auto;
	justify-content: space-between;
	margin-right: -1 * size('s');
	overflow: hidden;

	@include above('medium') {
		flex: 1 1 auto;
	}

	@include above('large') {
		flex-grow: 0;
		width: 72rem;
	}

	.row.mobile & {
		overflow: visible;
	}
}

.image {
	flex: 0 0 auto;
	width: 80vw;
	margin-bottom: size('m');
	transition: transform time('slow');
	transform: translateX(-20%);

	@include above('medium') {
		width: 70%;
		margin-bottom: 0;
		transform: none;
	}

	@include above('large') {
		width: 45%;
	}

	.row:global(.isActive) &,
	.row:global(.past) & {
		transform: none;
	}

	img {
		border-radius: 50%;
	}
}

.nextImage {
	margin-left: size('s');
	cursor: pointer;
	opacity: 0.3;
}
</style>
